<script lang="ts">
// 声明额外的选项
export default {
  name: "Edit"
};
</script>
<script setup lang="ts">
import { inject, onMounted, reactive, ref, Uploadfile, UploadImg, Editor, useRenderIcon, ElMessage, ElMessageBox, Upload, Close, http, getGroupUrl, RegularVerification, verification } from "@/utils/importUsed"
// 接口列表实例
let UrlList = reactive(null)
// 获取当前板块接口列表
onMounted(async () => {
  UrlList = await getGroupUrl(["prizeSet"]);

})
const props = defineProps<{
  editVisible: {
    type: Boolean;
    default: false;
  };
  width: {
    type: Number;
    default: 50;
  };
  formData: {
    id: any;
    type: any;
    default: {};
  };
}>();
// 表单数据
const UpdateForm: any = ref({

});

// 表单实例
const ruleFormRef = ref()

// 选项卡参数(默认值为列表某项的id)
const activeId = ref('1')
// 提交函数
const submit = async (formEl) => {
  // 表单校验拦截
  if (!formEl) return
  await formEl.validate(async (valid, fields) => {
    if (valid) {
      //表单校验成功回调
      console.log('submit!')

      // 需动态生成接口
      const { status, msg }: any = await http.Request({
        method: UrlList.prizeSet.pageUpdateInfoupdate.method,
        url: UrlList.prizeSet.pageUpdateInfoupdate.url,
        params: UpdateForm.value
      });
      if (status === 1) {
        //业务成功回调
        ElMessage({
          message: "修改成功",
          type: "success"
        });
        UpdateForm.value = {

        };
        // 关闭修改弹窗;
        closeUpdateVisible();
      } else {
        //业务失败回调
        ElMessageBox.alert(msg, "提示", {
          confirmButtonText: "关闭",
          type: "warning"
        });
      }
    } else {
      //表单校验失败回调
      ElMessage({
        message: "请输入完整信息",
        type: "error"
      });
    }
  })
};




// 表单校验规则
const rules = reactive({

})
// 关闭弹窗回调函数
const closeFn: any = inject('closeEditUpdateVisible');
const openVisible = async () => {
  //通过ID获取表格数据
  const { status, data }: any = await http.Request({ method: UrlList.prizeSet.pageUpdateInfoquery.method, url: UrlList.prizeSet.pageUpdateInfoquery.url, params: { id: props.formData.id } });
  if (status === 1) {
    UpdateForm.value = data;

  }
};
// 关闭弹窗回调函数
const closeUpdateVisible = () => {
  UpdateForm.value = {

  };
  closeFn();
};

// 弹窗是否全屏
const isFullscreen = ref(false)
</script>

<template lang="pug">
.main
  el-dialog(v-model='props.editVisible' draggable width="50%" :fullscreen="isFullscreen" title="修改" @close="closeUpdateVisible" @open="openVisible")
    el-tabs(v-model="activeId" class="demo-tabs" @tab-click="handleClick")
      el-tab-pane(label="基本信息" name="1")
        el-form(:model='UpdateForm' label-position="right" ref="ruleFormRef" :rules="rules" label-width="100px")
          el-form-item(label='模板更新版本' prop="moduleVersion")
            el-input-number(v-model='UpdateForm.moduleVersion' :min="1" :max="1000"
              placeholder="请输入模板更新版本")
          el-form-item(label='模板路径' prop="modulePath")
            el-input(v-model='UpdateForm.modulePath' autocomplete='off'
              placeholder="请输入模板路径")
          el-form-item(label='背景色' prop="backgroudColor")
            el-input(v-model='UpdateForm.backgroudColor' autocomplete='off'
              placeholder="请输入背景色")
          el-form-item(label='前景色' prop="textColor")
            el-input(v-model='UpdateForm.textColor' autocomplete='off'
              placeholder="请输入前景色")
          el-form-item(label="苹果状态栏", prop="statusBarStyle")
            el-select(
              v-model="UpdateForm.statusBarStyle",
              placeholder="请选择苹果状态栏",
              clearable,
            )
              el-option(:label="item.label", :value="item.id" v-for="(item,index) in statusBarStyleOptionList")
          el-form-item(label='是否显示头部' prop="showTitle")
            el-switch(v-model="UpdateForm.showTitle")
          el-form-item(label='顶部标题' prop="title")
            el-input(v-model='UpdateForm.title' autocomplete='off'
              placeholder="请输入顶部标题")
          el-form-item(label='是否显示滚动条' prop="showScrollBar")
            el-switch(v-model="UpdateForm.showScrollBar")
          el-form-item(label='是否侧滑返回' prop="skidFlag")
            el-switch(v-model="UpdateForm.skidFlag")
          el-form-item(label='左侧按钮1' prop="leftBtn1")
            el-input(v-model='UpdateForm.leftBtn1' autocomplete='off'
              placeholder="请输入左侧按钮1")
          el-form-item(label='左侧按钮2' prop="leftBtn2")
            el-input(v-model='UpdateForm.leftBtn2' autocomplete='off'
              placeholder="请输入左侧按钮2")
          el-form-item(label='右侧按钮1' prop="rightBtn1")
            el-input(v-model='UpdateForm.rightBtn1' autocomplete='off'
              placeholder="请输入右侧按钮1")
          el-form-item(label='右侧按钮2' prop="rightBtn2")
            el-input(v-model='UpdateForm.rightBtn2' autocomplete='off'
              placeholder="请输入右侧按钮2")
          el-form-item(label='左侧按钮1点击事件' prop="leftAction1")
            el-input(v-model='UpdateForm.leftAction1' autocomplete='off'
              placeholder="请输入左侧按钮1点击事件")
          el-form-item(label='左侧按钮2点击事件' prop="leftAction2")
            el-input(v-model='UpdateForm.leftAction2' autocomplete='off'
              placeholder="请输入左侧按钮2点击事件")
          el-form-item(label='右侧按钮1点击事件' prop="rightAction1")
            el-input(v-model='UpdateForm.rightAction1' autocomplete='off'
              placeholder="请输入右侧按钮1点击事件")
          el-form-item(label='右侧按钮2点击事件' prop="rightAction2")
            el-input(v-model='UpdateForm.rightAction2' autocomplete='off'
              placeholder="请输入右侧按钮2点击事件")
          el-form-item(label='是否读取网页标题' prop="webTitle")
            el-switch(v-model="UpdateForm.webTitle")
      el-tab-pane(label="下级页面" name="2")
        el-form(:model='UpdateForm' label-position="right" ref="ruleFormRef" :rules="rules" label-width="100px")
          el-form-item(label="下级页面", prop="gotoPages")
            el-transfer(v-model="UpdateForm.gotoPages" :data="gotoPagesOptionList")
      el-tab-pane(label="基本资料" name="3")
        el-form(:model='UpdateForm' label-position="right" ref="ruleFormRef" :rules="rules" label-width="100px")
          el-form-item(label='是否强制更新' prop="mustUpdate")
            el-switch(v-model="UpdateForm.mustUpdate")

    .flex.justify-end
      el-button(
        :icon="useRenderIcon(Close)",
        :loading="loading",
        @click="closeUpdateVisible()"
      ) 关闭
      el-button(
        type="primary",
        :icon="useRenderIcon(Upload)",
        @click="submit(ruleFormRef)"
      ) 确认提交
</template>

<style scoped lang="scss">
:deep(.el-dropdown-menu__item i) {
  margin: 0;
}

:deep(.el-form-item__label) {
  font-weight: 700;
}

:deep(.el-pagination) {
  flex-flow: wrap;
}

:deep(.is-draggable) {
  max-height: 80vh;
  overflow: auto;
}

:deep(.el-dialog__header) {
  position: sticky;
  top: 0;
  z-index: 2;
  background: #fff;
}

.collapsedom {
  padding: 0 20px;
  background-color: #fff;
}

.ovh-x {
  height: 40vh;
  overflow-y: auto;
}

:deep(.el-descriptions__header) {
  margin: 16px 0 !important;
}

.el-select {
  width: 100%;
}
</style>
